-
AI-powered Extensions
-
Data Grid
-
Tree List
-
Chat
-
HTML Editor
-
Form
-
-
Data Grids / Data Management
-
Data Grid
- Overview
-
Data Binding
-
Filtering
- Sorting
-
Editing
-
Grouping
-
Selection
- Focused Row
- Paging
-
Scrolling
-
Columns
- AI Assistant
-
Master-Detail
-
Data Summaries
-
Drag & Drop
-
Export to PDF
-
Export to Excel
- Appearance
-
Customization
- State Persistence
-
Adaptability
-
Keyboard Navigation
- Right-To-Left Support
-
Tree List
- Overview
-
Data Binding
-
Filtering
- Sorting
-
Editing
-
Selection
- Focused Row
- Paging
-
Columns
- Drag & Drop
- State Persistence
- Adaptability
-
Keyboard Navigation
-
Card View
-
Pivot Grid
- Overview
-
Data Binding
-
Field Management
-
Data Summaries
- Drill Down
- Filtering
-
Scrolling
-
Export to Excel
- Chart Integration
- Customization
- State Persistence
-
Filter Builder
-
-
Data Visualization
-
Charts
- Overview
-
Data Binding
-
Common Concepts
-
Axis
-
Aggregation
-
Tooltips
-
Selection
-
Customization
-
Zooming
-
Export
-
-
Area Charts
-
Bar Charts
- Bullet Charts
-
Doughnut Charts
-
Financial Charts
-
Funnel and Pyramid Charts
-
Line Charts
- Pareto Chart
-
Pie Charts
-
Point Charts
-
Polar and Radar Charts
-
Range Charts
- Sankey Chart
-
Sparkline Charts
-
Tree Map
-
Gauges
- Overview
-
Runtime update
-
Bar Gauge
-
Circular Gauge
-
Linear Gauge
-
Diagram
- Overview
-
Data Binding
-
Featured Shapes
-
Custom Shapes
-
Document Capabilities
-
User Interaction
- UI Customization
- Adaptability
-
-
Scheduling / Planning
-
Scheduler
- Overview
-
Data Binding
-
Views
-
Appointments
-
Timetable
- Editing
-
Grouping
- Virtual Scrolling
- Drag & Drop
-
Customization
- Adaptability
-
Gantt
- Overview
- Data Binding
-
Filtering
- Sorting
- Strip Lines
- Export to PDF
- Validation
-
Customization
-
-
Messaging
-
WYSIWYG Editor
-
Forms
-
Data Editors
- Overview
-
Common Concepts
-
Calendar
- Check Box
- Color Box
-
Date Box
-
Date Range Box
-
Number Box
- Radio Group
-
Range Selector
- Range Slider
- Slider
- Switch
- Text Area
- Text Box
-
Drop-Downs
- Autocomplete
-
Drop Down Box
-
Select Box
-
Tag Box
-
Lookup
-
Buttons
-
File Upload / File Management
-
File Manager
- Overview
-
File System Types
-
Customization
-
File Uploader
-
-
Popup and Notifications
-
Navigation
- Overview
- Accordion
-
Action Sheet
-
Context Menu
-
Menu
- Multi View
-
Drawer
-
Tab Panel
-
Tabs
-
Toolbar
-
Stepper
- Pagination
-
List
-
Tree View
- Right-to-Left Support
-
Layout
-
Interactive Wrappers
-
Sortable
- Resizable
-
-
Progress Indicators
-
Maps
- Overview
-
Map
-
Vector Map
-
Data Binding
- Multiple Layers
-
Markers
- Legend
-
Zooming and Panning
-
Customization
-
-
Localization
Related Demos:
Your search did not match any results.
JavaScript/jQuery Charts - Tooltip Customization
To set the tooltip's content, specify the contentTemplate. Inside the template, you can identify the chart series point for which the tooltip is displayed and thus display information related to that point.
Backend API
$(() => {
$('#pie-chart').dxPieChart({
palette: 'bright',
dataSource: states,
title: 'Top 10 Most Populated States in US',
series: {
argumentField: 'name',
valueField: 'population',
},
export: {
enabled: true,
},
tooltip: {
enabled: true,
contentTemplate(info, container) {
const contentItems = [`<div class='state-tooltip'><img src='../../../../images/flags/${
info.point.data.name.replace(/\s/, '')}.svg' />`,
"<h4 class='state'></h4>",
"<div class='capital'><span class='caption'>Capital</span>: </div>",
"<div class='population'><span class='caption'>Population</span>: </div>",
"<div><span class='caption'>Area</span>: ",
"<span class='area-km'></span> km<sup>2</sup> (",
"<span class='area-mi'></span> mi<sup>2</sup>)",
'</div></div>'];
const content = $(contentItems.join(''));
content.find('.state').text(info.argument);
content.find('.capital').append(document.createTextNode(info.point.data.capital));
content.find('.population').append(document.createTextNode(`${formatNumber(info.value)} people`));
content.find('.area-km').text(formatNumber(info.point.data.area));
content.find('.area-mi').text(formatNumber(0.3861 * info.point.data.area));
content.appendTo(container);
},
},
});
});
const formatNumber = new Intl.NumberFormat('en-US', { maximumFractionDigits: 0 }).format;
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
<script>window.jQuery || document.write(decodeURIComponent('%3Cscript src="js/jquery.min.js"%3E%3C/script%3E'))</script>
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/26.1.4/css/dx.light.css" />
<script src="js/dx.all.js?v=26.1.4"></script>
<script src="data.js"></script>
<link rel="stylesheet" type="text/css" href="styles.css" />
<script src="index.js"></script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="pie-chart"></div>
</div>
</body>
</html>
#pie-chart {
height: 440px;
}
.state-tooltip {
height: 90px;
}
.state-tooltip > img {
width: 60px;
height: 40px;
display: block;
margin: 0 5px 0 0;
float: left;
border: 1px solid rgba(191, 191, 191, 0.25);
}
.state-tooltip > h4 {
line-height: 40px;
font-size: 14px;
margin-bottom: 5px;
}
.state-tooltip .caption {
font-weight: 500;
}
.state-tooltip sup {
font-size: 0.8em;
vertical-align: super;
line-height: 0;
}
const states = [{
name: 'California',
population: 38802500,
capital: 'Sacramento',
area: 423967,
}, {
name: 'Texas',
population: 26956958,
capital: 'Austin',
area: 695662,
}, {
name: 'Florida',
population: 19893297,
capital: 'Tallahassee',
area: 170312,
}, {
name: 'New York',
population: 19746227,
capital: 'Albany',
area: 141297,
}, {
name: 'Illinois',
population: 12880580,
capital: 'Springfield',
area: 149995,
}, {
name: 'Pennsylvania',
population: 12787209,
capital: 'Harrisburg',
area: 119280,
}, {
name: 'Ohio',
population: 11594163,
capital: 'Columbus',
area: 116098,
}, {
name: 'Georgia',
population: 10097343,
capital: 'Atlanta',
area: 153910,
}, {
name: 'North Carolina',
population: 9943964,
capital: 'Raleigh',
area: 139391,
}, {
name: 'Michigan',
population: 9909877,
capital: 'Lansing',
area: 250487,
}];

-
AI-powered Extensions
-
Data Grid
-
Tree List
-
Chat
-
HTML Editor
-
Form
-
-
Data Grids / Data Management
-
Data Grid
- Overview
-
Data Binding
-
Filtering
- Sorting
-
Editing
-
Grouping
-
Selection
- Focused Row
- Paging
-
Scrolling
-
Columns
- AI Assistant
-
Master-Detail
-
Data Summaries
-
Drag & Drop
-
Export to PDF
-
Export to Excel
- Appearance
-
Customization
- State Persistence
-
Adaptability
-
Keyboard Navigation
- Right-To-Left Support
-
Tree List
- Overview
-
Data Binding
-
Filtering
- Sorting
-
Editing
-
Selection
- Focused Row
- Paging
-
Columns
- Drag & Drop
- State Persistence
- Adaptability
-
Keyboard Navigation
-
Card View
-
Pivot Grid
- Overview
-
Data Binding
-
Field Management
-
Data Summaries
- Drill Down
- Filtering
-
Scrolling
-
Export to Excel
- Chart Integration
- Customization
- State Persistence
-
Filter Builder
-
-
Data Visualization
-
Charts
- Overview
-
Data Binding
-
Common Concepts
-
Axis
-
Aggregation
-
Tooltips
-
Selection
-
Customization
-
Zooming
-
Export
-
-
Area Charts
-
Bar Charts
- Bullet Charts
-
Doughnut Charts
-
Financial Charts
-
Funnel and Pyramid Charts
-
Line Charts
- Pareto Chart
-
Pie Charts
-
Point Charts
-
Polar and Radar Charts
-
Range Charts
- Sankey Chart
-
Sparkline Charts
-
Tree Map
-
Gauges
- Overview
-
Runtime update
-
Bar Gauge
-
Circular Gauge
-
Linear Gauge
-
Diagram
- Overview
-
Data Binding
-
Featured Shapes
-
Custom Shapes
-
Document Capabilities
-
User Interaction
- UI Customization
- Adaptability
-
-
Scheduling / Planning
-
Scheduler
- Overview
-
Data Binding
-
Views
-
Appointments
-
Timetable
- Editing
-
Grouping
- Virtual Scrolling
- Drag & Drop
-
Customization
- Adaptability
-
Gantt
- Overview
- Data Binding
-
Filtering
- Sorting
- Strip Lines
- Export to PDF
- Validation
-
Customization
-
-
Messaging
-
WYSIWYG Editor
-
Forms
-
Data Editors
- Overview
-
Common Concepts
-
Calendar
- Check Box
- Color Box
-
Date Box
-
Date Range Box
-
Number Box
- Radio Group
-
Range Selector
- Range Slider
- Slider
- Switch
- Text Area
- Text Box
-
Drop-Downs
- Autocomplete
-
Drop Down Box
-
Select Box
-
Tag Box
-
Lookup
-
Buttons
-
File Upload / File Management
-
File Manager
- Overview
-
File System Types
-
Customization
-
File Uploader
-
-
Popup and Notifications
-
Navigation
- Overview
- Accordion
-
Action Sheet
-
Context Menu
-
Menu
- Multi View
-
Drawer
-
Tab Panel
-
Tabs
-
Toolbar
-
Stepper
- Pagination
-
List
-
Tree View
- Right-to-Left Support
-
Layout
-
Tile View
- Splitter
-
Gallery
- Scroll View
- Box
- Responsive Box
-
-
Interactive Wrappers
-
Sortable
- Resizable
-
-
Progress Indicators
-
Maps
- Overview
-
Map
-
Vector Map
-
Data Binding
- Multiple Layers
-
Markers
- Legend
-
Zooming and Panning
-
Customization
-
-
Localization
Related Demos:
Your search did not match any results.
Vue Charts - Tooltip Customization
To set the tooltip's content, specify the contentTemplate. Inside the template, you can identify the chart series point for which the tooltip is displayed and thus display information related to that point.
Backend API
<template>
<div>
<DxPieChart
id="pie-chart"
:data-source="populationData"
palette="Bright"
title="Top 10 Most Populated States in US"
>
<DxSeries
argument-field="name"
value-field="population"
/>
<DxExport
:enabled="true"
/>
<DxTooltip
:enabled="true"
content-template="tooltipTemplate"
/>
<template #tooltipTemplate="{ data }">
<TooltipTemplate :info="data"/>
</template>
</DxPieChart>
</div>
</template>
<script setup lang="ts">
import {
DxPieChart, DxSeries, DxExport, DxTooltip,
} from 'devextreme-vue/pie-chart';
import { populationData } from './data.ts';
import TooltipTemplate from './TooltipTemplate.vue';
</script>
<style scoped>
#pie-chart {
height: 440px;
}
</style>
<template>
<div class="state-tooltip">
<img :src="getImagePath(info.point)"><h4 class="state">{{ info.argument }}</h4>
<div class="capital">
<span class="caption">Capital</span>: {{ info.point?.data.capital }}
</div>
<div>
<span class="caption">Population</span>:
<span class="population">{{ formatNumber(Number(info.value)) }}</span>
people
</div>
<div>
<span class="caption">Area</span>:
<span class="area-km">{{ formatNumber(info.point?.data.area) }}</span>
km<sup>2</sup>
(<span class="area-mi">{{ formatNumber(0.3861 * info.point?.data.area) }}</span>
mi<sup>2</sup>)
</div>
</div>
</template>
<script setup lang="ts">
import type { DxPieChartTypes } from 'devextreme-vue/pie-chart';
defineProps<{
info: DxPieChartTypes.PointInfo
}>();
const getImagePath = (
point: DxPieChartTypes.PointInfo['point'],
) => `../../../../images/flags/${point?.data.name.replace(/\s/, '')}.svg`;
const formatNumber = new Intl.NumberFormat('en-US', {
maximumFractionDigits: 0,
}).format;
</script>
<style>
.state-tooltip {
height: 90px;
}
.state-tooltip > img {
width: 60px;
height: 40px;
display: block;
margin: 0 5px 0 0;
float: left;
border: 1px solid rgba(191, 191, 191, 0.25);
}
.state-tooltip > h4 {
line-height: 40px;
font-size: 14px;
margin-bottom: 5px;
}
.state-tooltip .caption {
font-weight: 500;
}
.state-tooltip sup {
font-size: 0.8em;
vertical-align: super;
line-height: 0;
}
</style>
window.exports = window.exports || {};
window.config = {
transpiler: false,
meta: {
'*.vue': {
loader: 'vue-loader',
},
'*.ts': {
loader: 'demo-ts-loader',
},
'*.svg': {
loader: 'svg-loader',
},
'typescript': {
'exports': 'ts',
},
'vue': {
format: 'global',
exports: 'Vue',
esModule: true,
},
'vuex': {
format: 'global',
exports: 'Vuex',
esModule: true,
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'openai': {
'esModule': true,
},
'zod': {
'esModule': true,
},
'zod-to-json-schema': {
'esModule': true,
},
'anti-forgery': {
loader: 'demo-ts-loader',
},
},
paths: {
'project:': '../../../../',
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
'anti-forgery:': '../../../../shared/anti-forgery/',
'loaders:': '../../../../shared/loaders/',
},
map: {
'anti-forgery': 'anti-forgery:fetch-override.js',
'vue': 'npm:vue@3.5.40/dist/vue.global.js',
'@vue/shared': 'npm:@vue/shared@3.4.26/dist/shared.cjs.prod.js',
'dx-systemjs-vue-browser': 'npm:dx-systemjs-vue-browser@1.1.2/index.js',
'demo-ts-loader': 'loaders:demo-ts-loader.js',
'demo-ts-shared': 'loaders:demo-ts-shared.js',
'vue-loader': 'loaders:demo-vue-loader.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
'svg-loader': 'project:utils/svg-loader.js',
'mitt': 'npm:mitt/dist/mitt.umd.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-vue': 'npm:devextreme-vue@link:../../packages/devextreme-vue/npm/cjs',
'zod': 'externals:zod.bundle.js',
'zod-to-json-schema': 'externals:zod-to-json-schema.bundle.js',
'devextreme-quill': 'npm:devextreme-quill@1.7.10/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.29/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.69/dist/dx-gantt.js',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.14.4/dist/signals-core.min.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
},
packages: {
'devextreme-vue': {
main: 'index.js',
},
'devextreme-vue/common': {
main: 'index.js',
},
'devextreme': {
defaultExtension: 'js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
],
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
let packagesInfo = {
"zod": {
"version": "3.24.4"
},
"zod-to-json-schema": {
"version": "3.24.6"
}
};
export const populationData = [{
name: 'California',
population: 38802500,
capital: 'Sacramento',
area: 423967,
}, {
name: 'Texas',
population: 26956958,
capital: 'Austin',
area: 695662,
}, {
name: 'Florida',
population: 19893297,
capital: 'Tallahassee',
area: 170312,
}, {
name: 'New York',
population: 19746227,
capital: 'Albany',
area: 141297,
}, {
name: 'Illinois',
population: 12880580,
capital: 'Springfield',
area: 149995,
}, {
name: 'Pennsylvania',
population: 12787209,
capital: 'Harrisburg',
area: 119280,
}, {
name: 'Ohio',
population: 11594163,
capital: 'Columbus',
area: 116098,
}, {
name: 'Georgia',
population: 10097343,
capital: 'Atlanta',
area: 153910,
}, {
name: 'North Carolina',
population: 9943964,
capital: 'Raleigh',
area: 139391,
}, {
name: 'Michigan',
population: 9909877,
capital: 'Lansing',
area: 250487,
}];
import { createApp } from 'vue';
import App from './App.vue';
createApp(App).mount('#app');
<!DOCTYPE html>
<html lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/26.1.4/css/dx.light.css" />
<script type="module">
import * as vueCompilerSFC from "https://cdn.jsdelivr.net/npm/@vue/compiler-sfc@3.4.27/dist/compiler-sfc.esm-browser.js";
window.vueCompilerSFC = vueCompilerSFC;
</script>
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import("./index.ts");
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app"> </div>
</div>
</body>
</html>

Backend API
<dx-pie-chart
id="pie-chart"
[dataSource]="populationData"
palette="bright"
title="Top 10 Most Populated States in US"
>
<dxi-pie-chart-series argumentField="name" valueField="population">
</dxi-pie-chart-series>
<dxo-pie-chart-tooltip [enabled]="true" contentTemplate="content">
</dxo-pie-chart-tooltip>
<dxo-pie-chart-export [enabled]="true"></dxo-pie-chart-export>
<div *dxTemplate="let info of 'content'" class="state-tooltip">
<img src="{{ getImagePath(info.point) }}" /><h4 class="state">{{
info.argument
}}</h4>
<div class="capital">
<span class="caption">Capital</span>: {{ info.point.data.capital }}
</div>
<div class="population">
<span class="caption">Population</span>:
{{ info.value | number : "3.0-0" }} people
</div>
<div>
<span class="caption">Area</span>:
<span class="area-km">{{ info.point.data.area | number : "3.0-0" }}</span>
km<sup>2</sup> (<span class="area-mi">{{
0.3861 * info.point.data.area | number : "3.0-0"
}}</span>
mi<sup>2</sup>)
</div>
</div>
</dx-pie-chart>
import { bootstrapApplication } from '@angular/platform-browser';
import { Component, enableProdMode, provideZoneChangeDetection } from '@angular/core';
import { DecimalPipe } from '@angular/common';
import { DxPieChartModule } from 'devextreme-angular';
import { Service, State } from './app.service';
if (!/localhost/.test(document.location.host)) {
enableProdMode();
}
let modulePrefix = '';
// @ts-ignore
if (window && window.config?.packageConfigPaths) {
modulePrefix = '/app';
}
@Component({
selector: 'demo-app',
providers: [Service],
templateUrl: `app/app.component.html`,
styleUrls: [`app/app.component.css`],
imports: [
DxPieChartModule,
DecimalPipe,
],
})
export class AppComponent {
populationData: State[];
constructor(service: Service) {
this.populationData = service.getPopulationData();
}
getImagePath = ({ data: { name } }) => `../../../../images/flags/${name.replace(/\s/, '')}.svg`;
}
bootstrapApplication(AppComponent, {
providers: [
provideZoneChangeDetection({ eventCoalescing: true, runCoalescing: true }),
],
});
::ng-deep #pie-chart {
height: 440px;
}
::ng-deep .state-tooltip {
height: 90px;
}
::ng-deep .state-tooltip > img {
width: 60px;
height: 40px;
display: block;
margin: 0 5px 0 0;
float: left;
border: 1px solid rgba(191, 191, 191, 0.25);
}
::ng-deep .state-tooltip > h4 {
line-height: 40px;
font-size: 14px;
margin-bottom: 5px;
}
::ng-deep .state-tooltip .caption {
font-weight: 500;
}
::ng-deep .state-tooltip sup {
font-size: 0.8em;
vertical-align: super;
line-height: 0;
}
import { Injectable } from '@angular/core';
export interface State {
name: string;
population: number;
capital: string;
area: number;
}
const populationData: State[] = [{
name: 'California',
population: 38802500,
capital: 'Sacramento',
area: 423970,
}, {
name: 'Texas',
population: 26956958,
capital: 'Austin',
area: 695662,
}, {
name: 'Florida',
population: 19893297,
capital: 'Tallahassee',
area: 170312,
}, {
name: 'New York',
population: 19746227,
capital: 'Albany',
area: 141297,
}, {
name: 'Illinois',
population: 12880580,
capital: 'Springfield',
area: 149995,
}, {
name: 'Pennsylvania',
population: 12787209,
capital: 'Harrisburg',
area: 119280,
}, {
name: 'Ohio',
population: 11594163,
capital: 'Columbus',
area: 116098,
}, {
name: 'Georgia',
population: 10097343,
capital: 'Atlanta',
area: 153910,
}, {
name: 'North Carolina',
population: 9943964,
capital: 'Raleigh',
area: 139391,
}, {
name: 'Michigan',
population: 9909877,
capital: 'Lansing',
area: 250487,
}];
@Injectable()
export class Service {
getPopulationData(): State[] {
return populationData;
}
}
// In real applications, you should not transpile code in the browser.
// You can see how to create your own application with Angular and DevExtreme here:
// https://js.devexpress.com/Documentation/Guide/Angular_Components/Getting_Started/Create_a_DevExtreme_Application/
const componentNames = [
'accordion',
'action-sheet',
'autocomplete',
'bar-gauge',
'box',
'bullet',
'button-group',
'button',
'calendar',
'card-view',
'chart',
'chat',
'check-box',
'circular-gauge',
'color-box',
'context-menu',
'data-grid',
'date-box',
'date-range-box',
'defer-rendering',
'diagram',
'draggable',
'drawer',
'drop-down-box',
'drop-down-button',
'file-manager',
'file-uploader',
'filter-builder',
'form',
'funnel',
'gallery',
'gantt',
'html-editor',
'linear-gauge',
'list',
'load-indicator',
'load-panel',
'lookup',
'map',
'menu',
'multi-view',
'nested',
'number-box',
'pagination',
'pie-chart',
'pivot-grid-field-chooser',
'pivot-grid',
'polar-chart',
'popover',
'popup',
'progress-bar',
'radio-group',
'range-selector',
'range-slider',
'recurrence-editor',
'resizable',
'responsive-box',
'sankey',
'scheduler',
'scroll-view',
'select-box',
'slider',
'sortable',
'sparkline',
'speech-to-text',
'speed-dial-action',
'splitter',
'stepper',
'switch',
'tab-panel',
'tabs',
'tag-box',
'text-area',
'text-box',
'tile-view',
'toast',
'toolbar',
'tooltip',
'tree-list',
'tree-map',
'tree-view',
'validation-group',
'validation-summary',
'validator',
'vector-map',
];
window.exports = window.exports || {};
window.config = {
transpiler: false,
meta: {
'*.ts': {
loader: 'demo-ts-loader',
},
'typescript': {
'exports': 'ts',
},
'anti-forgery': {
loader: 'demo-ts-loader',
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'@angular/platform-browser-dynamic': {
'esModule': true,
},
'@angular/platform-browser': {
'esModule': true,
},
'@angular/core': {
'esModule': true,
},
'@angular/common': {
'esModule': true,
},
'@angular/common/http': {
'esModule': true,
},
'@angular/animations': {
'esModule': true,
},
'@angular/forms': {
'esModule': true,
},
'openai': {
'esModule': true,
},
'zod': {
'esModule': true,
},
'zod-to-json-schema': {
'esModule': true,
},
},
paths: {
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
'anti-forgery:': '../../../../shared/anti-forgery/',
'loaders:': '../../../../shared/loaders/',
},
map: {
'anti-forgery': 'anti-forgery:fetch-override.js',
'demo-ts-loader': 'loaders:demo-ts-loader.js',
'demo-ts-shared': 'loaders:demo-ts-shared.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
/* @angular */
'@angular/compiler': 'bundles:@angular/compiler.umd.js',
'@angular/platform-browser-dynamic': 'bundles:@angular/platform-browser-dynamic.umd.js',
'@angular/core': 'bundles:@angular/core.umd.js',
'@angular/core/primitives/signals': 'bundles:@angular/core.primitives.signals.umd.js',
'@angular/core/primitives/di': 'bundles:@angular/core.primitives.di.umd.js',
'@angular/common': 'bundles:@angular/common.umd.js',
'@angular/common/http': 'bundles:@angular/common-http.umd.js',
'@angular/platform-browser': 'bundles:@angular/platform-browser.umd.js',
'@angular/platform-browser/animations': 'bundles:@angular/platform-browser.umd.js',
'@angular/forms': 'bundles:@angular/forms.umd.js',
/* devextreme */
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-quill': 'npm:devextreme-quill@1.7.10/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.29',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.69',
/* devextreme-angular umd maps */
'devextreme-angular': 'bundles:devextreme-angular/devextreme-angular.umd.js',
'devextreme-angular/common/ai-integration': 'bundles:devextreme-angular/devextreme-angular-common-ai-integration.umd.js',
'devextreme-angular/core': 'bundles:devextreme-angular/devextreme-angular-core.umd.js',
'devextreme-angular/common/charts': 'bundles:devextreme-angular/devextreme-angular-common-charts.umd.js',
'devextreme-angular/common/core/animation': 'bundles:devextreme-angular/devextreme-angular-common-core-animation.umd.js',
'devextreme-angular/common/core/environment': 'bundles:devextreme-angular/devextreme-angular-common-core-environment.umd.js',
'devextreme-angular/common/core/events': 'bundles:devextreme-angular/devextreme-angular-common-core-events.umd.js',
'devextreme-angular/common/core/localization': 'bundles:devextreme-angular/devextreme-angular-common-core-localization.umd.js',
'devextreme-angular/common/core': 'bundles:devextreme-angular/devextreme-angular-common-core.umd.js',
'devextreme-angular/common/data/custom-store': 'bundles:devextreme-angular/devextreme-angular-common-data-custom-store.umd.js',
'devextreme-angular/common/data': 'bundles:devextreme-angular/devextreme-angular-common-data.umd.js',
'devextreme-angular/common/export/excel': 'bundles:devextreme-angular/devextreme-angular-common-export-excel.umd.js',
'devextreme-angular/common/export/pdf': 'bundles:devextreme-angular/devextreme-angular-common-export-pdf.umd.js',
'devextreme-angular/common/export': 'bundles:devextreme-angular/devextreme-angular-common-export.umd.js',
'devextreme-angular/common/grids': 'bundles:devextreme-angular/devextreme-angular-common-grids.umd.js',
'devextreme-angular/common': 'bundles:devextreme-angular/devextreme-angular-common.umd.js',
'devextreme-angular/http': 'bundles:devextreme-angular/devextreme-angular-http.umd.js',
'devextreme-angular/core/tokens': 'bundles:devextreme-angular/devextreme-angular-core-tokens.umd.js',
...componentNames.reduce((acc, name) => {
acc[`devextreme-angular/ui/${name}`] = `bundles:devextreme-angular/devextreme-angular-ui-${name}.umd.js`;
acc[`devextreme-angular/ui/${name}/nested`] = `bundles:devextreme-angular/devextreme-angular-ui-${name}-nested.umd.js`;
return acc;
}, {}),
'zod': 'externals:zod.bundle.js',
'zod-to-json-schema': 'externals:zod-to-json-schema.bundle.js',
'tslib': 'npm:tslib/tslib.js',
'rxjs': 'npm:rxjs@7.5.3/dist/bundles/rxjs.umd.js',
'rxjs/operators': 'npm:rxjs@7.5.3/dist/cjs/operators/index.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.14.4/dist/signals-core.min.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
'zone.js': 'npm:zone.js@0.16.2/bundles/zone.umd.js',
},
packages: {
'app': {
main: './app.component.ts',
defaultExtension: 'ts',
},
'devextreme': {
defaultExtension: 'js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
'rxjs': {
defaultExtension: 'js',
},
'rxjs/operators': {
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
'npm:rxjs@7.5.3/package.json',
'npm:rxjs@7.5.3/operators/package.json',
'npm:devexpress-diagram@2.2.29/package.json',
'npm:devexpress-gantt@4.1.69/package.json',
],
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line no-console
// System.import('@angular/compiler').catch(console.error.bind(console));
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
let packagesInfo = {
"zod": {
"version": "3.24.4"
},
"zod-to-json-schema": {
"version": "3.24.6"
},
"@angular/core": {
"version": "22.1.0"
},
"core-js": {
"version": "2.6.12"
},
"typescript": {
"version": "6.0.3"
},
"zone.js": {
"version": "0.16.2"
}
};
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/26.1.4/css/dx.light.css" />
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/zone.js@0.16.2/bundles/zone.umd.js"></script>
<script src="https://cdn.jsdelivr.net/npm/reflect-metadata@0.1.13/Reflect.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script src="config.js"></script>
<script>
System.import("app").catch(console.error.bind(console));
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<demo-app>Loading...</demo-app>
</div>
</body>
</html>

Backend API
import React from 'react';
import PieChart, {
Series,
Tooltip,
Export,
} from 'devextreme-react/pie-chart';
import { populationData } from './data.ts';
import TooltipTemplate from './TooltipTemplate.tsx';
function App() {
return (
<PieChart
id="pie-chart"
dataSource={populationData}
title="Top 10 Most Populated States in US"
palette="Bright"
>
<Series
argumentField="name"
valueField="population"
/>
<Tooltip
enabled={true}
contentRender={TooltipTemplate}
/>
<Export enabled={true} />
</PieChart>
);
}
export default App;
import React from 'react';
import PieChart, { Series, Tooltip, Export } from 'devextreme-react/pie-chart';
import { populationData } from './data.js';
import TooltipTemplate from './TooltipTemplate.js';
function App() {
return (
<PieChart
id="pie-chart"
dataSource={populationData}
title="Top 10 Most Populated States in US"
palette="Bright"
>
<Series
argumentField="name"
valueField="population"
/>
<Tooltip
enabled={true}
contentRender={TooltipTemplate}
/>
<Export enabled={true} />
</PieChart>
);
}
export default App;
import React from 'react';
import type { PieChartTypes } from 'devextreme-react/pie-chart';
function getImagePath(point: PieChartTypes.PointInfo['point']): string {
return `../../../../images/flags/${point?.data.name.replace(/\s/, '')}.svg`;
}
const formatNumber = new Intl.NumberFormat('en-US', {
maximumFractionDigits: 0,
}).format;
export default function TooltipTemplate(info: PieChartTypes.PointInfo) {
return (
<div className="state-tooltip">
<img src={getImagePath(info.point)} /><h4 className="state">{info.argument}</h4>
<div className="capital">
<span className="caption">Capital</span>: {info.point?.data.capital}
</div>
<div className="population">
<span className="caption">Population</span>: {formatNumber(Number(info.value))} people
</div>
<div>
<span className="caption">Area</span>: <span className="area-km">{formatNumber(info.point?.data.area)}</span> km<sup>2</sup> (<span className="area-mi">{formatNumber(0.3861 * info.point?.data.area)}</span> mi<sup>2</sup>)
</div>
</div>
);
}
import React from 'react';
import ReactDOM from 'react-dom';
import App from './App.tsx';
ReactDOM.render(
<App />,
document.getElementById('app'),
);
export const populationData = [{
name: 'California',
population: 38802500,
capital: 'Sacramento',
area: 423967,
}, {
name: 'Texas',
population: 26956958,
capital: 'Austin',
area: 695662,
}, {
name: 'Florida',
population: 19893297,
capital: 'Tallahassee',
area: 170312,
}, {
name: 'New York',
population: 19746227,
capital: 'Albany',
area: 141297,
}, {
name: 'Illinois',
population: 12880580,
capital: 'Springfield',
area: 149995,
}, {
name: 'Pennsylvania',
population: 12787209,
capital: 'Harrisburg',
area: 119280,
}, {
name: 'Ohio',
population: 11594163,
capital: 'Columbus',
area: 116098,
}, {
name: 'Georgia',
population: 10097343,
capital: 'Atlanta',
area: 153910,
}, {
name: 'North Carolina',
population: 9943964,
capital: 'Raleigh',
area: 139391,
}, {
name: 'Michigan',
population: 9909877,
capital: 'Lansing',
area: 250487,
}];
window.exports = window.exports || {};
window.config = {
transpiler: false,
meta: {
'*.ts': {
loader: 'demo-ts-loader',
},
'*.tsx': {
loader: 'demo-ts-loader',
typescriptOptions: {
jsx: 'react',
},
},
'typescript': {
'exports': 'ts',
},
'anti-forgery': {
loader: 'demo-ts-loader',
},
'react': {
'esModule': true,
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'openai': {
'esModule': true,
},
'zod': {
'esModule': true,
},
'zod-to-json-schema': {
'esModule': true,
},
},
paths: {
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
'anti-forgery:': '../../../../shared/anti-forgery/',
'loaders:': '../../../../shared/loaders/',
},
defaultExtension: 'js',
map: {
'anti-forgery': 'anti-forgery:fetch-override.js',
'demo-ts-loader': 'loaders:demo-ts-loader.js',
'demo-ts-shared': 'loaders:demo-ts-shared.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
'react': 'npm:react@17.0.2/umd/react.development.js',
'react-dom': 'npm:react-dom@17.0.2/umd/react-dom.development.js',
'prop-types': 'npm:prop-types/prop-types.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-react': 'npm:devextreme-react@link:../../packages/devextreme-react/npm/cjs',
'zod': 'externals:zod.bundle.js',
'zod-to-json-schema': 'externals:zod-to-json-schema.bundle.js',
'devextreme-quill': 'npm:devextreme-quill@1.7.10/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.29/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.69/dist/dx-gantt.js',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.14.4/dist/signals-core.min.js',
'devextreme-cldr-data': 'npm:devextreme-cldr-data@1.0.3',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
},
packages: {
'devextreme': {
defaultExtension: 'js',
},
'devextreme-react': {
main: 'index.js',
},
'devextreme-react/common': {
main: 'index.js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/localization/messages': {
format: 'json',
defaultExtension: 'json',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
],
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
let packagesInfo = {
"zod": {
"version": "3.24.4"
},
"zod-to-json-schema": {
"version": "3.24.6"
}
};
import React from 'react';
function getImagePath(point) {
return `../../../../images/flags/${point?.data.name.replace(/\s/, '')}.svg`;
}
const formatNumber = new Intl.NumberFormat('en-US', {
maximumFractionDigits: 0,
}).format;
export default function TooltipTemplate(info) {
return (
<div className="state-tooltip">
<img src={getImagePath(info.point)} />
<h4 className="state">{info.argument}</h4>
<div className="capital">
<span className="caption">Capital</span>: {info.point?.data.capital}
</div>
<div className="population">
<span className="caption">Population</span>: {formatNumber(Number(info.value))} people
</div>
<div>
<span className="caption">Area</span>:{' '}
<span className="area-km">{formatNumber(info.point?.data.area)}</span> km<sup>2</sup> (
<span className="area-mi">{formatNumber(0.3861 * info.point?.data.area)}</span> mi
<sup>2</sup>)
</div>
</div>
);
}
import React from 'react';
import ReactDOM from 'react-dom';
import App from './App.js';
ReactDOM.render(<App />, document.getElementById('app'));
export const populationData = [
{
name: 'California',
population: 38802500,
capital: 'Sacramento',
area: 423967,
},
{
name: 'Texas',
population: 26956958,
capital: 'Austin',
area: 695662,
},
{
name: 'Florida',
population: 19893297,
capital: 'Tallahassee',
area: 170312,
},
{
name: 'New York',
population: 19746227,
capital: 'Albany',
area: 141297,
},
{
name: 'Illinois',
population: 12880580,
capital: 'Springfield',
area: 149995,
},
{
name: 'Pennsylvania',
population: 12787209,
capital: 'Harrisburg',
area: 119280,
},
{
name: 'Ohio',
population: 11594163,
capital: 'Columbus',
area: 116098,
},
{
name: 'Georgia',
population: 10097343,
capital: 'Atlanta',
area: 153910,
},
{
name: 'North Carolina',
population: 9943964,
capital: 'Raleigh',
area: 139391,
},
{
name: 'Michigan',
population: 9909877,
capital: 'Lansing',
area: 250487,
},
];
<!DOCTYPE html>
<html lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/26.1.4/css/dx.light.css" />
<link rel="stylesheet" type="text/css" href="styles.css" />
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import("./index.tsx");
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app"></div>
</div>
</body>
</html>
#pie-chart {
height: 440px;
}
.state-tooltip {
height: 90px;
}
.state-tooltip > img {
width: 60px;
height: 40px;
display: block;
margin: 0 5px 0 0;
float: left;
border: 1px solid rgba(191, 191, 191, 0.25);
}
.state-tooltip > h4 {
line-height: 40px;
font-size: 14px;
margin-bottom: 5px;
}
.state-tooltip .caption {
font-weight: 500;
}
.state-tooltip sup {
font-size: 0.8em;
vertical-align: super;
line-height: 0;
}